package org.ssssssss.magicboot.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.xxl.job.core.context.XxlJobHelper;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;
import org.ssssssss.magicboot.fxapi.XKTokenAccess;
import org.ssssssss.magicboot.fxapi.model.CrmFXApiParam;
import org.ssssssss.magicboot.zdyutils.FXHTTP;
import org.ssssssss.magicboot.zdyutils.FXTIC;
import org.ssssssss.magicboot.zdyutils.GcjJson;
import org.ssssssss.magicboot.zdyutils.MagicApi;

import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.*;

@RestController
@RequestMapping("/customer")
public class customerController {
    static Logger log = LoggerFactory.getLogger("customer");

    public static void main(String[] args) throws Exception {
            new customerController().getSynDataAdd();
            new customerController().getSynKH();

    }

    public void getSynDataAdd() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "AccountObj";

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("IS", "erp_id__c", ""),
                new CrmFXApiParam("ISN", "erp_category__c", ""),
                new CrmFXApiParam("EQ", "sync_status__c", "option_test__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );


         //  List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name", "灵宝市窄口水务管理局"));

        JSONObject jsonject = fxapi.getSynNewDataObj(false, "客户", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");


        List<CrmFXApiParam> paramListB = Arrays.asList(
                new CrmFXApiParam("EQ", "sync_status__c", "option_resync__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );
        JSONObject jsonjectB = fxapi.getSynNewDataObj(false, "客户重新同步", apiName, paramListB);
        JSONArray arrayA = jsonjectB.getJSONObject("data").getJSONArray("dataList");
        array.addAll(arrayA);


        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";
            String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";


            String syn_type = "0";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行客户" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行客户" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDataCustomer("KH", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                    if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                        tbflag = false;
                    }
                }
                if (tbflag) {
                    continue;
                }
                log.info("客户待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "KH"); //业务类型
                jsonObjectData.put("send_syn", "0"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", endtime);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDatacustomer(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }

    public void getSynKH() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/queryCustomer?sendType=KH&sendStatus=3&sendSyn=0", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步客户数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "0";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
                String societycreditcode = GcjJson.getNodeValue(str, "JSON.uniform_social_credit_code") != null ? GcjJson.getNodeValue(str, "JSON.uniform_social_credit_code").toString() : "";
                String simplename = GcjJson.getNodeValue(str, "JSON.abbreviation__c") != null ? GcjJson.getNodeValue(str, "JSON.abbreviation__c").toString() : "";

                String account_no = GcjJson.getNodeValue(str, "JSON.account_no") != null ? GcjJson.getNodeValue(str, "JSON.account_no").toString() : "";
                String erp_category__c = GcjJson.getNodeValue(str, "JSON.erp_category__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_category__c").toString() : "";

                String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";
                String status = GcjJson.getNodeValue(str, "JSON.sync_status__c") != null ? GcjJson.getNodeValue(str, "JSON.sync_status__c").toString() : "";

                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataCustomer("KH", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                        if("option_resync__c".equals(status) && !endtime.equals(dataSyn.getString("mark"))){
                            tbflag = false;
                        }
                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();
                    //统一社会信用代码
                    datajson.put("societycreditcode",societycreditcode);
                    //简称
                    datajson.put("simplename",simplename);
                    datajson.put("taxrate_number","V13");//税率
                    datajson.put("settlementcyid_number","CNY");//交易币.货币代码
                    //纳税人识别号
                    datajson.put("tx_register_no",societycreditcode);
                    //编码
                    datajson.put("number",account_no);
                    datajson.put("paymentcurrency_number","CNY");//付款币种.货币代码
                    datajson.put("name",nameData);//客户名称
                    datajson.put("f9w5_crmid",dataId);//CRMID
                   // datajson.put("settlementtypeid_number","JSFS04");//结算方式

                    JSONArray groupstandardarr = new JSONArray();
                    JSONObject groupstandardjson = new JSONObject();
                    groupstandardjson.put("groupid_number",erp_category__c);
                    groupstandardjson.put("standardid_number","JBFLBZ");
                    groupstandardarr.add(groupstandardjson);
                    datajson.put("entry_groupstandard",groupstandardarr);//分类标准



                    JSONArray lxrarr = new JSONArray();
                    JSONObject jsonjectZ = fxapi.getSynDataObj("客户下联系人", "ContactObj", "account_id", dataId);
                    JSONArray arrayZ = jsonjectZ.getJSONObject("data").getJSONArray("dataList");
                    if (!arrayZ.isEmpty()){
                        for (int j = 0; j < arrayZ.size(); j++) {
                            JSONObject stra = arrayZ.getJSONObject(j);
                            JSONObject lxrjson = new JSONObject();
                            lxrjson.put("contactperson",GcjJson.getNodeValue(stra, "JSON.name"));
                            lxrjson.put("contactpersonpost",GcjJson.getNodeValue(stra, "JSON.job_title"));
                            lxrjson.put("dept",GcjJson.getNodeValue(stra, "JSON.department"));
                            lxrjson.put("email",GcjJson.getNodeValue(stra, "JSON.email"));
                            lxrjson.put("phone",GcjJson.getNodeValue(stra, "JSON.mobile1"));
                            if(j==0){
                            lxrjson.put("isdefault_linkman",true);
                            }
                            lxrarr.add(lxrjson);
                        }
                     datajson.put("entry_linkman",lxrarr);//联系人
                    }

                    JSONArray groupstandardarr2 = new JSONArray();
                    JSONObject jsonjectC = fxapi.getSynDataObj("客户下财务信息", "AccountFinInfoObj", "account_id", dataId);
                    JSONArray arrayC = jsonjectC.getJSONObject("data").getJSONArray("dataList");
                    if (!arrayC.isEmpty()){
                        for (int j = 0; j < arrayC.size(); j++) {
                            JSONObject stra = arrayC.getJSONObject(j);
                            JSONObject groupstandardjson2 = new JSONObject();
                            groupstandardjson2.put("bank_number",GcjJson.getNodeValue(stra, "JSON.bank_name_branch_number__c"));
                            groupstandardjson2.put("accountname",GcjJson.getNodeValue(stra, "JSON.account_name__c"));
                            groupstandardjson2.put("currency_number","CNY");
                            groupstandardjson2.put("bankaccount",GcjJson.getNodeValue(stra, "JSON.account_bank_no"));

                            groupstandardjson2.put("isdefault_bank",false);
                            if(j==0){
                                groupstandardjson2.put("isdefault_bank",true);
                            }
                            groupstandardarr2.add(groupstandardjson2);
                        }
                        datajson.put("entry_bank",groupstandardarr2);//银行信息
                    }



                    //创建组织
                    datajson.put("createorg_number","zyierp");
                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSave(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }
    /**
     * 写数据
     */
    public void getSynDataSave(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "0";//同步类型 0新增 1修改 2删除
        String res_url = "http://192.168.31.158:8022/ierp/kapi/v2/f9w5/basedata/bd_customer/customerSave";
        String res_param = obj;
        String res = "";
        try {
           // String token = "2096108315279888384_HJyMZK1Lco9gSZUKU1ipq85P5J32eQDdaz8WgChd1DvHrPZylIodiBmBYa8U2smKVC8MKAspXtjNQ2Fjw5MlWXDnkn5nPFPQWzSB03";
            String accessToken = new KDTokenController().getKDAccessTokenTest();


            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");

                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("erp_id__c", erpid);//数据ID
                paramMap.put("sync_status__c", "option_sync_success__c");
                paramMap.put("sync_info__c", resjs.getString("message"));
                //fxapi.lock(false, dataId, "AccountObj");
                //回写json
                fxapi.upSynFieldParam("", "AccountObj", dataId, paramMap);
            }else{
                sendFlag=true;
                stringBuffer.append("客户创建接口调用失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
                paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynFieldParam("", "AccountObj", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("客户创建接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynFieldParam("", "AccountObj", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATEcustomer(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "KH"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveCustomerLog(logData);
    }


    public void getSynDataUpdate() throws Exception {
        FXHTTP fxapi = new FXHTTP();
        XKTokenAccess xktonken = new XKTokenAccess();
        // 查询magic接口
        //获取时间戳
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String time = sdf.format(System.currentTimeMillis() - (1000 * 60 * 60));

        String apiName = "AccountObj";

        List<CrmFXApiParam> paramList = Arrays.asList(
                new CrmFXApiParam("GT", "last_modified_time", System.currentTimeMillis() - (1000 * 60 * 60 * 24)),
                new CrmFXApiParam("ISN", "erp_id__c", ""),
                new CrmFXApiParam("ISN", "erp_category__c", ""),
                new CrmFXApiParam("EQ", "sync_status__c", "option_sync_success__c"),
                new CrmFXApiParam("EQ", "life_status", "normal")
        );


        //  List<CrmFXApiParam> paramList = Arrays.asList(new CrmFXApiParam("EQ", "name", "国网湖北省电力有限公司武汉供电公司"));

        JSONObject jsonject = fxapi.getSynNewDataObj(false, "客户", apiName, paramList);
        JSONArray array = jsonject.getJSONObject("data").getJSONArray("dataList");


        for (int i = 0; i < array.size(); i++) {
            JSONObject str = array.getJSONObject(i);
            String dataId = GcjJson.getNodeValue(str,  "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
            String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
            String endtime = GcjJson.getNodeValue(str, "JSON.last_modified_time") != null ? GcjJson.getNodeValue(str, "JSON.last_modified_time").toString() : "";

            String syn_type = "1";//同步类型 0新增 1修改 2删除
            log.info("-------------------开始执行客户" + i + " -------------------" + nameData);
            XxlJobHelper.log("-------------------开始执行客户" + i + " -------------------" + nameData);

            Boolean sendFlag = false;
            StringBuffer stringBuffer = new StringBuffer();

            try {
                boolean tbflag = false;
                //验证数据是否已存在
                JSONObject dataSyn = MagicApi.getSendSYNDataCustomer("KH", syn_type, dataId);

                if (dataSyn != null && dataId.equals(dataSyn.getString("crmId")) && endtime.equals(dataSyn.getString("mark")) ) {
                    log.info("数据已存在-" + nameData);
                    XxlJobHelper.log("--数据已存在---" + nameData);
                    tbflag = true;
                }
                if (tbflag) {
                    continue;
                }
                log.info("客户待同步数据-" + i + " ------" + nameData);
                JSONObject jsonObjectData = new JSONObject();
                jsonObjectData.put("send_type", "KH"); //业务类型
                jsonObjectData.put("send_syn", "1"); //同步类型 0新增 1修改 2删除
                jsonObjectData.put("crm_id", dataId);//数据id
                jsonObjectData.put("crmzhu_id", dataId);//数据id
                jsonObjectData.put("send_status", 3);//同步状态 true同步成功 false同步失败 3待同步
                jsonObjectData.put("crm_code", nameData);//数据名称
                jsonObjectData.put("mark", endtime);//标识
                jsonObjectData.put("crm_json", str.toJSONString());//标识

                MagicApi.saveSendSYNDatacustomer(jsonObjectData);
            } catch (Exception e) {
                continue;
            }

        }
    }

    public void getSynKHUPdate() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
        FXHTTP fxapi = new FXHTTP();
        String resJsonStr = MagicApi.getWNRES("http://localhost:18088/syn/queryCustomer?sendType=KH&sendStatus=3&sendSyn=1", "");
        JSONObject resJson = JSON.parseObject(resJsonStr);
        if (resJson != null) {
            log.info("待同步客户数" + resJson.getJSONArray("data").size());
            for (int i = 0; i < resJson.getJSONArray("data").size(); i++) {

                JSONObject getData = resJson.getJSONArray("data").getJSONObject(i);
                JSONObject str = getData.getJSONObject("crmJson");
                String syn_type = "1";//同步类型 0新增 1修改 2删除
                Boolean sendFlag = false;
                StringBuffer stringBuffer = new StringBuffer();
                boolean tbflag = false;
                // 构建json

                String dataId = GcjJson.getNodeValue(str, "JSON._id") != null ? GcjJson.getNodeValue(str, "JSON._id").toString() : "";
                String nameData = GcjJson.getNodeValue(str, "JSON.name") != null ? GcjJson.getNodeValue(str, "JSON.name").toString() : "";
                String societycreditcode = GcjJson.getNodeValue(str, "JSON.uniform_social_credit_code") != null ? GcjJson.getNodeValue(str, "JSON.uniform_social_credit_code").toString() : "";
                String simplename = GcjJson.getNodeValue(str, "JSON.abbreviation__c") != null ? GcjJson.getNodeValue(str, "JSON.abbreviation__c").toString() : "";

                String account_no = GcjJson.getNodeValue(str, "JSON.account_no") != null ? GcjJson.getNodeValue(str, "JSON.account_no").toString() : "";
                String erp_category__c = GcjJson.getNodeValue(str, "JSON.erp_category__c") != null ? GcjJson.getNodeValue(str, "JSON.erp_category__c").toString() : "";


                String strJson = "";
                try{
                    JSONObject dataSyn = MagicApi.getSendSYNDataCustomer("KH", syn_type, dataId,"3");
                    if (dataSyn != null && dataId.equals(dataSyn.getString("crmId"))) {
                        log.info("数据已存在-" + nameData);
                        XxlJobHelper.log("--数据已存在---" + nameData);
                        tbflag = true;
                    }
                    if (tbflag) {
                        continue;
                    }

                    JSONObject params = new JSONObject();

                    JSONArray dataarr = new JSONArray();
                    JSONObject datajson = new JSONObject();
                    //统一社会信用代码
                    datajson.put("societycreditcode",societycreditcode);
                    //简称
                    datajson.put("simplename",simplename);
                    datajson.put("taxrate_number","V13");//税率
                    datajson.put("settlementcyid_number","CNY");//交易币.货币代码
                    //纳税人识别号
                    datajson.put("tx_register_no",societycreditcode);
                    //编码
                    datajson.put("number",account_no);
                    datajson.put("paymentcurrency_number","CNY");//付款币种.货币代码
                    datajson.put("name","新-"+nameData);//客户名称
                    datajson.put("f9w5_crmid",dataId);//CRMID
                    // datajson.put("settlementtypeid_number","JSFS04");//结算方式

                    JSONArray groupstandardarr = new JSONArray();
                    JSONObject groupstandardjson = new JSONObject();
                    groupstandardjson.put("groupid_number",erp_category__c);
                    groupstandardjson.put("standardid_number","JBFLBZ");
                    groupstandardarr.add(groupstandardjson);
                    datajson.put("entry_groupstandard",groupstandardarr);//分类标准


                    JSONArray lxrarr = new JSONArray();
                    JSONObject jsonjectZ = fxapi.getSynDataObj("客户下联系人", "ContactObj", "account_id", dataId);
                    JSONArray arrayZ = jsonjectZ.getJSONObject("data").getJSONArray("dataList");
                    if (!arrayZ.isEmpty()){
                        for (int j = 0; j < arrayZ.size(); j++) {
                            JSONObject stra = arrayZ.getJSONObject(j);
                            JSONObject lxrjson = new JSONObject();
                            lxrjson.put("contactperson",GcjJson.getNodeValue(stra, "JSON.name"));
                            lxrjson.put("contactpersonpost",GcjJson.getNodeValue(stra, "JSON.job_title"));
                            lxrjson.put("dept",GcjJson.getNodeValue(stra, "JSON.department"));
                            lxrjson.put("email",GcjJson.getNodeValue(stra, "JSON.email"));
                            lxrjson.put("phone",GcjJson.getNodeValue(stra, "JSON.mobile1"));
                            if(j==0){
                                lxrjson.put("isdefault_linkman",true);
                            }
                            lxrarr.add(lxrjson);
                        }
                        datajson.put("entry_linkman",lxrarr);//联系人
                    }

                    JSONArray groupstandardarr2 = new JSONArray();
                    JSONObject jsonjectC = fxapi.getSynDataObj("客户下财务信息", "AccountFinInfoObj", "account_id", dataId);
                    JSONArray arrayC = jsonjectC.getJSONObject("data").getJSONArray("dataList");
                    if (!arrayC.isEmpty()){
                        for (int j = 0; j < arrayC.size(); j++) {
                            JSONObject stra = arrayC.getJSONObject(j);
                            JSONObject groupstandardjson2 = new JSONObject();
                            groupstandardjson2.put("bank_number",GcjJson.getNodeValue(stra, "JSON.bank_name_branch_number__c"));
                            groupstandardjson2.put("accountname",GcjJson.getNodeValue(stra, "JSON.account_name__c"));
                            groupstandardjson2.put("currency_number","CNY");
                            groupstandardjson2.put("bankaccount",GcjJson.getNodeValue(stra, "JSON.account_bank_no"));

                            groupstandardjson2.put("isdefault_bank",false);
                            if(j==0){
                                groupstandardjson2.put("isdefault_bank",true);
                            }
                            groupstandardarr2.add(groupstandardjson2);
                        }
                        datajson.put("entry_bank",groupstandardarr2);//银行信息
                    }



                    //创建组织
                    datajson.put("createorg_number","zyierp");
                    dataarr.add(datajson);
                    params.put("data",dataarr);
                    log.info("--请求json---" + params.toJSONString());
                    System.out.println("--请求json:---" +params.toJSONString());
                    strJson = params.toJSONString();

                }catch  (Exception e) {
                    sendFlag = true;
                    stringBuffer.append("参数解析错误，请联系开发人员");
                    e.printStackTrace();
                }
                getSynDataSaveup(stringBuffer,sendFlag,fxapi,dataId,nameData,strJson,getData);

            }
        }
    }

    public void getSynDataSaveup(StringBuffer stringBuffer,Boolean sendFlag,FXHTTP fxapi,String dataId,String nameData,String obj,JSONObject str) {
        String syn_type = "1";//同步类型 0新增 1修改 2删除
        String res_url = "http://192.168.31.158:8022/ierp/kapi/v2/f9w5/basedata/bd_customer/customerSave";
        String res_param = obj;
        String res = "";
        try {
          //  String token = "2096108315279888384_HJyMZK1Lco9gSZUKU1ipq85P5J32eQDdaz8WgChd1DvHrPZylIodiBmBYa8U2smKVC8MKAspXtjNQ2Fjw5MlWXDnkn5nPFPQWzSB03";
            String accessToken = new KDTokenController().getKDAccessTokenTest();



            Map<String, String> headers = new HashMap<String, String>();
            headers.put("accessToken",  accessToken);//放token
            HttpClientResult rtn = HttpClientUtils.doPostJson(res_url, headers, obj);
            String resStr =  rtn.getContent();
            JSONObject resjs = JSONObject.parseObject(resStr);
            res = resStr;
            if (resjs != null && resjs.getBoolean("status")) {
                JSONObject successdata  =  resjs.getJSONObject("data");
                JSONArray result = successdata.getJSONArray("result");
                JSONObject erpdata = (JSONObject) result.get(0);
                String erpid = erpdata.getString("id");
                Map<String, Object> paramMap = new HashMap<String, Object>();
                // paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", "修改成功");
                //回写json
                fxapi.upSynFieldParam("", "AccountObj", dataId, paramMap);

            }else{
                sendFlag=true;
                stringBuffer.append("客户修改失败:"+resjs.getString("message"));
                Map<String, Object> paramMap = new HashMap<String, Object>();
               // paramMap.put("sync_status__c", "option_sync_failure__c");
                paramMap.put("sync_info__c", stringBuffer);
                //回写json
                fxapi.upSynFieldParam("", "AccountObj", dataId, paramMap);
            }
        } catch (Exception e) {
            sendFlag = true;
            stringBuffer.append("客户修改接口调用失败,请检查网络配置");
            Map<String, Object> paramMap = new HashMap<String, Object>();
            //paramMap.put("sync_status__c", "option_sync_failure__c");
            paramMap.put("sync_info__c", stringBuffer);
            //回写json
            fxapi.upSynFieldParam("", "AccountObj", dataId, paramMap);
        }

        JSONObject sendData = new JSONObject();

        sendData.put("send_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步

        sendData.put("send_id", str.getString("sendId")); //send_id
        MagicApi.updateSendSYUPDATEcustomer(sendData);

        JSONObject logData = new JSONObject();
        logData.put("log_type", "KH"); //业务类型
        logData.put("log_status", !sendFlag);//同步状态 true同步成功 false同步失败 3待同步
        logData.put("syn_type", syn_type);//同步类型 0新增 1修改 2删除
        logData.put("data_id", dataId);//数据id
        logData.put("data_name", nameData);//数据名称
        logData.put("res_body", "同步成功");//返回值
        logData.put("res_url", res_url);//
        logData.put("res_param", res_param);//
        logData.put("res_res", res);//
        if (sendFlag) {
            logData.put("res_body", stringBuffer.toString());//返回值
        }
        //写入传输日志
        MagicApi.saveCustomerLog(logData);
    }
}
