package org.ssssssss.magicboot.zdyutils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.ssssssss.magicboot.fxapi.HttpClientResult;
import org.ssssssss.magicboot.fxapi.HttpClientUtils;

import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

public class ThPost {
    private static final Logger log = LoggerFactory.getLogger(ThPost.class);

    public static void main(String[] args) {
       String delResult =  ThPost.deleteObj("PayBill","1002312130000048");
       System.out.println("delReslut ========= "+ delResult);
    }

    public static String approveObj(String keyWord ,String U9ID) {
        String delReslut  = "";
        try {
            LinkedHashMap map1 = new LinkedHashMap<String, Object>();
            U9TokenAccess tonken = new U9TokenAccess();
            String token = tonken.getCorpAccessU9Token().getData();

            map1.put("token",token);
            String delUrl = "http://192.168.1.21/U9C/webapi/"+keyWord+"/Approve";
            JSONObject delData = new JSONObject();
            JSONArray delArray = new JSONArray();
            delData.put("ID",U9ID);
            delArray.add(delData);
            System.out.println("ApproveArray ========== " +keyWord +"ID :   "+delArray);
            HttpClientResult rtn =  HttpClientUtils.doPostJson(delUrl,map1, delArray.toJSONString());
            delReslut = rtn.getContent();
        } catch (Exception e) {
//            e.printStackTrace();
            log.info("审批接口传输错误"+e);
        }
        return delReslut;
    }

    public static String submitObj(String keyWord ,String dataId) {
        String delReslut  = "";
        try {
            LinkedHashMap map1 = new LinkedHashMap<String, Object>();
            U9TokenAccess tonken = new U9TokenAccess();
            String token = tonken.getCorpAccessU9Token().getData();

            map1.put("token",token);
            String delUrl = "http://192.168.1.21/U9C/webapi/"+keyWord+"/Submit";
            JSONObject delData = new JSONObject();
            JSONArray delArray = new JSONArray();
            delData.put("ID",dataId);
            delArray.add(delData);
            System.out.println("submitArray ========== " +keyWord +"ID :   "+delArray);
            HttpClientResult rtn =  HttpClientUtils.doPostJson(delUrl,map1, delArray.toJSONString());
            delReslut = rtn.getContent();
        } catch (Exception e) {
//            e.printStackTrace();
            log.info("提交接口传输错误"+e);
        }
        return delReslut;
    }

    public static String deleteObj(String keyWord ,String dataId) {
        String delReslut  = "";
        try {
            LinkedHashMap map1 = new LinkedHashMap<String, Object>();
            U9TokenAccess tonken = new U9TokenAccess();
            String token = tonken.getCorpAccessU9Token().getData();

            map1.put("token",token);
            String delUrl = "http://192.168.1.21/U9C/webapi/"+keyWord+"/Delete";
            JSONObject delData = new JSONObject();
            JSONArray delArray = new JSONArray();
            delData.put("ID",dataId);
            delArray.add(delData);
            System.out.println("delArray ========== " +keyWord +"ID :   "+delArray);
            HttpClientResult rtn =  HttpClientUtils.doPostJson(delUrl,map1, delArray.toJSONString());
            delReslut = rtn.getContent();
        } catch (Exception e) {
//            e.printStackTrace();
            log.info("删除接口传输错误"+e);
        }
        return delReslut;
    }

    public static  String getCreateReturnData (String methodName,String content ,String dataId ,String apiName ,
                                     String U9ID_CrmApiName, String U9Code_CrmApiName ,FXHTTP fxapi){
        JSONObject contentJson = JSON.parseObject(content);
        JSONObject getReData = contentJson.getJSONArray("Data").getJSONObject(0);
        String  U9ID = "";
        try {
              U9ID = GcjJson.getNodeStrValue(getReData,"JSON.ID");
            String U9Code = GcjJson.getNodeStrValue(getReData,"JSON.Code");
            Map<String, Object> dataMap = new HashMap<>();
            dataMap.put(U9ID_CrmApiName,U9ID);
            dataMap.put(U9Code_CrmApiName,U9Code);
            fxapi.upSynZDYFieldParam(methodName, apiName,dataId,dataMap);
            if (U9ID.equals("")){
                return null;
            }
        } catch (Exception e) {
            log.error(methodName+"数据回写异常",e);
        }
        return U9ID;

    }
}
